﻿--
-- Taarup 22cm^3
-- 
-- author  Mythos
-- date  23/06/2015
-- www.ARM-team.gr
-- Copyright (C) ARM Team, All Rights Reserved.

Taarup22 = {};

function Taarup22.prerequisitesPresent(specializations)
    return true;
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:load(xmlFile)

	-- Functions
	self.MPCode = SpecializationUtil.callSpecializationsFunction("MPCode");
	
	-- Anims
	self.doorAnim = getXMLString(xmlFile, "vehicle.doorAnim#animationName");
	
	-- Booleans
	self.DM = false;

end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:delete()
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:mouseEvent(posX, posY, isDown, isUp, button)
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:keyEvent(unicode, sym, modifier, isDown)
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:update(dt)
	
	if self:getIsActive() then
		if InputBinding.hasEvent(InputBinding.TAARUP22_DOOR_MODE) then
			self:MPCode(1, not self.DM);
		end;
		
	end;
	
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:updateTick(dt)
	
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:MPCode(mode, state, angle, a1, a2, a3, noEventSend)
	Taarup22Event.sendEvent(self, mode, state, angle, a1, a2, a3, noEventSend);

--______________________________________________________________________________
	if mode == 1 then
--_____________________________________ DOOR MODE ______________________________
		if state then
			self:playAnimation(self.doorAnim, 1, nil, true);
			self.DM = true;
		else
			self:playAnimation(self.doorAnim, -1, nil, true);
			self.DM = false;
		end;
	end;

end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:draw()
	
	g_currentMission:addHelpButtonText(string.format(g_i18n:getText("TAARUP22_DOOR_MODE"), self.typeDesc), InputBinding.TAARUP22_DOOR_MODE);
	
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles then
		self.DM = Utils.getNoNil(getXMLBool(xmlFile, key.."#DM"),false);
		
		self:MPCode(1, self.DM);
		
	end;
	
	return BaseMission.VEHICLE_LOAD_OK;
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'DM="'..tostring(self.DM)..'"';
	self:MPCode(1, self.DM);

	local nodes = nil;
	
	return attributes,nodes;
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:readStream(streamId, connection)
	self.DM = streamReadBool(streamId);
	self:MPCode(1, self.DM, true);
end;

--________________________________________________________________________________________________________________________________________________________
function Taarup22:writeStream(streamId, connection)
	streamWriteBool(streamId, self.DM);
end;

--**********************************************************************************************************************************************************************************
Taarup22Event = {};
Taarup22Event_mt = Class(Taarup22Event, Event);

InitEventClass(Taarup22Event, "Taarup22Event");

function Taarup22Event:emptyNew()
    local self = Event:new(Taarup22Event_mt);
    self.className="Taarup22Event";
    return self;
end;

function Taarup22Event:new(vehicle, mode, state)
    local self = Taarup22Event:emptyNew()
    self.vehicle = vehicle;
	self.mode = mode;
	self.state = state;
    return self;
end;

function Taarup22Event:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.mode = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function Taarup22Event:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteInt32(streamId, self.mode);
	streamWriteBool(streamId, self.state);
end;

function Taarup22Event:run(connection)
	self.vehicle:MPCode(self.mode, self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(Taarup22Event:new(self.vehicle, self.mode, self.state), nil, connection, self.vehicle);
    end;
end;

function Taarup22Event.sendEvent(vehicle, mode, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(Taarup22Event:new(vehicle, mode, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(Taarup22Event:new(vehicle, mode, state));
		end;
	end;
end;